#ifndef EFL_IO_SIZER_FD_EO_HH
#define EFL_IO_SIZER_FD_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_sizer.eo.h"
#include "efl_io_sizer_fd.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_io_sizer.eo.hh"
namespace efl { namespace io { namespace sizer { 
struct Fd;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::sizer::Fd> : ::std::true_type {}; } }
namespace efl { namespace io { namespace sizer { 
struct Fd;
} } } 
namespace efl { namespace io { 
struct Sizer;
} } 

namespace eo_cxx {
namespace efl { namespace io { namespace sizer { 
struct Fd {
   ::efl::eolian::return_traits<int>::type sizer_fd_get() const;
   ::efl::eolian::return_traits<void>::type sizer_fd_set( ::efl::eolian::in_traits<int>::type fd) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_SIZER_FD_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::sizer::Fd() const;
   operator ::efl::io::sizer::Fd&();
   operator ::efl::io::sizer::Fd const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Fd,  ::efl::io::Sizer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Fd const ,  ::efl::io::Sizer const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace efl { namespace io { namespace sizer { 
struct Fd : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl ::io::Sizer)
{
   explicit Fd( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Fd(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Fd(Fd const& other) = default;
   Fd(Fd&& other) = default;
   Fd& operator=(Fd const& other) = default;
   Fd& operator=(Fd&& other) = default;
   Fd()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Fd( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Fd(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type sizer_fd_get() const;
   ::efl::eolian::return_traits<void>::type sizer_fd_set( ::efl::eolian::in_traits<int>::type fd) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_SIZER_FD_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Fd,  ::efl::io::Sizer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Fd const ,  ::efl::io::Sizer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Fd) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Fd>::value, "");
} } } 
#endif
